// Generated by LL1ParserGenerator by Viktor "AlgorithMan" Engelmann
//                                 http://www.AlgorithMan.de
#include<iostream>

bool verbose = false;

std::string ConsumeToken(std::string* lookahead, std::istream& is, int depth)
{
    if(verbose)
        std::cout << std::string(2*depth, ' ') << *lookahead << std::endl;

    std::string result = *lookahead;
    if(is.eof())
        *lookahead = "";
    else
    {
        is >> *lookahead;
        is.peek();
        if(is.fail())
            *lookahead = "";
    }

    return result;
}

// forward declarations
bool ParseExp(std::string* lookahead, std::istream& is, int depth);
bool ParseMult(std::string* lookahead, std::istream& is, int depth);
bool ParseExps(std::string* lookahead, std::istream& is, int depth);
bool ParseAtom(std::string* lookahead, std::istream& is, int depth);
bool ParseMults(std::string* lookahead, std::istream& is, int depth);
bool ParseDIGIT(std::string* lookahead, std::istream& is, int depth);
bool ParseDIGITS(std::string* lookahead, std::istream& is, int depth);

bool ParseExp(std::string* lookahead, std::istream& is, int depth)
{
    if(verbose)
        std::cout << std::string(2*depth, ' ') << "Exp, look-ahead=\"" << *lookahead << "\"" << std::endl;

    // Exp : Mult Exps
    if(*lookahead == "0" || *lookahead == "2" || *lookahead == "1" || *lookahead == "3" || *lookahead == "4" || *lookahead == "5" || *lookahead == "6" || *lookahead == "7" || *lookahead == "8" || *lookahead == "9" || *lookahead == "(")
    {
        if(!ParseMult(lookahead, is, depth+1)) return false;
        if(!ParseExps(lookahead, is, depth+1)) return false;
        return true;
    }

    return false;
}

bool ParseMult(std::string* lookahead, std::istream& is, int depth)
{
    if(verbose)
        std::cout << std::string(2*depth, ' ') << "Mult, look-ahead=\"" << *lookahead << "\"" << std::endl;

    // Mult : Atom Mults
    if(*lookahead == "0" || *lookahead == "2" || *lookahead == "1" || *lookahead == "3" || *lookahead == "4" || *lookahead == "5" || *lookahead == "6" || *lookahead == "7" || *lookahead == "8" || *lookahead == "9" || *lookahead == "(")
    {
        if(!ParseAtom(lookahead, is, depth+1)) return false;
        if(!ParseMults(lookahead, is, depth+1)) return false;
        return true;
    }

    return false;
}

bool ParseExps(std::string* lookahead, std::istream& is, int depth)
{
    if(verbose)
        std::cout << std::string(2*depth, ' ') << "Exps, look-ahead=\"" << *lookahead << "\"" << std::endl;

    // Exps : + Mult Exps
    if(*lookahead == "+")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "+") return false;
        if(!ParseMult(lookahead, is, depth+1)) return false;
        if(!ParseExps(lookahead, is, depth+1)) return false;
        return true;
    }

    // Exps :
    else if(*lookahead == ")" || *lookahead == "")
    {
        return true;
    }

    return false;
}

bool ParseAtom(std::string* lookahead, std::istream& is, int depth)
{
    if(verbose)
        std::cout << std::string(2*depth, ' ') << "Atom, look-ahead=\"" << *lookahead << "\"" << std::endl;

    // Atom : ( Exp )
    if(*lookahead == "(")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "(") return false;
        if(!ParseExp(lookahead, is, depth+1)) return false;
        if(ConsumeToken(lookahead, is, depth+1) != ")") return false;
        return true;
    }

    // Atom : DIGIT DIGITS
    else if(*lookahead == "0" || *lookahead == "2" || *lookahead == "1" || *lookahead == "3" || *lookahead == "4" || *lookahead == "5" || *lookahead == "6" || *lookahead == "7" || *lookahead == "8" || *lookahead == "9")
    {
        if(!ParseDIGIT(lookahead, is, depth+1)) return false;
        if(!ParseDIGITS(lookahead, is, depth+1)) return false;
        return true;
    }

    return false;
}

bool ParseMults(std::string* lookahead, std::istream& is, int depth)
{
    if(verbose)
        std::cout << std::string(2*depth, ' ') << "Mults, look-ahead=\"" << *lookahead << "\"" << std::endl;

    // Mults : * Atom Mults
    if(*lookahead == "*")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "*") return false;
        if(!ParseAtom(lookahead, is, depth+1)) return false;
        if(!ParseMults(lookahead, is, depth+1)) return false;
        return true;
    }

    // Mults :
    else if(*lookahead == ")" || *lookahead == "+" || *lookahead == "")
    {
        return true;
    }

    return false;
}

bool ParseDIGIT(std::string* lookahead, std::istream& is, int depth)
{
    if(verbose)
        std::cout << std::string(2*depth, ' ') << "DIGIT, look-ahead=\"" << *lookahead << "\"" << std::endl;

    // DIGIT : 0
    if(*lookahead == "0")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "0") return false;
        return true;
    }

    // DIGIT : 1
    else if(*lookahead == "1")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "1") return false;
        return true;
    }

    // DIGIT : 2
    else if(*lookahead == "2")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "2") return false;
        return true;
    }

    // DIGIT : 3
    else if(*lookahead == "3")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "3") return false;
        return true;
    }

    // DIGIT : 4
    else if(*lookahead == "4")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "4") return false;
        return true;
    }

    // DIGIT : 5
    else if(*lookahead == "5")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "5") return false;
        return true;
    }

    // DIGIT : 6
    else if(*lookahead == "6")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "6") return false;
        return true;
    }

    // DIGIT : 7
    else if(*lookahead == "7")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "7") return false;
        return true;
    }

    // DIGIT : 8
    else if(*lookahead == "8")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "8") return false;
        return true;
    }

    // DIGIT : 9
    else if(*lookahead == "9")
    {
        if(ConsumeToken(lookahead, is, depth+1) != "9") return false;
        return true;
    }

    return false;
}

bool ParseDIGITS(std::string* lookahead, std::istream& is, int depth)
{
    if(verbose)
        std::cout << std::string(2*depth, ' ') << "DIGITS, look-ahead=\"" << *lookahead << "\"" << std::endl;

    // DIGITS : DIGIT DIGITS
    if(*lookahead == "0" || *lookahead == "2" || *lookahead == "1" || *lookahead == "3" || *lookahead == "4" || *lookahead == "5" || *lookahead == "6" || *lookahead == "7" || *lookahead == "8" || *lookahead == "9")
    {
        if(!ParseDIGIT(lookahead, is, depth+1)) return false;
        if(!ParseDIGITS(lookahead, is, depth+1)) return false;
        return true;
    }

    // DIGITS :
    else if(*lookahead == ")" || *lookahead == "+" || *lookahead == "*" || *lookahead == "")
    {
        return true;
    }

    return false;
}

int main(int argc, char** argv)
{
    std::cout << "LL(1) Parser generated by LL1ParserGenerator by Viktor \"AlgorithMan\" Engelmann" << std::endl;
    std::cout << "                                             http://www.AlgorithMan.de" << std::endl;
    std::string lookahead;
    std::cin >> lookahead;
    if(argc > 1 && std::string(argv[1]) == "-v")
        verbose = true;
    std::cout << "Parsing stdin...\n";
    bool result = ParseExp(&lookahead, std::cin, 0);
    std::cout << (result ? "success" : "failed") << std::endl;
    return result ? 0 : 1;
}

